;============================================
; Library module source file:
;	GetConfigKey()
;
;============================================


	include \masm32\include\masm32rt.inc
	INCLUDE	config.inc


;============================================
; Defines, macros, prototypes, etc.
;============================================



;============================================
; HERE BE DATA
;============================================
.data



;============================================
; CODE LIVES HERE
;============================================
.code



;============================================
; GetConfigKey (keyTablePtr, keyName)
;
; Searches a configuration key table for a specified key. If found, returns
; the value of the key. (The value is always a NULL-terminated string.)
;
; NOTE: Values may be NULL (consisting only of the terminating zero).
;
; Parameters:
;
; keyTablePtr:
;	Pointer to key table previously filled
;	in by GetOurConfig()
; keyName:
;	Pointer to NULL-terminated string
;	key name to match
;
; Returns:
; 	Pointer to <value> string if found
;	NULL if no match
;============================================

GetConfigKey		PROC keyTablePtr:DWORD, keyName:DWORD

	PUSH	EBX
	PUSH	ESI
	PUSH	EDI
	MOV	EBX, keyTablePtr
gck10:	MOV	ESI, [EBX + $key.key]
	CMP	ESI, -1				;End o'list?
	JE	gck77				;  Yep, no match.
	MOV	EDI, keyName
	CALL	strcmpi
	OR	EAX, EAX
	JZ	next
; Found match: return pointer to <value>:
	MOV	EAX, [EBX + $key.val]
gck99:	POP	EDI
	POP	ESI
	POP	EBX
	RET

next:	ADD	EBX, SIZEOF $key
	JMP	gck10

gck77:	XOR	EAX, EAX			;Return NULL if no match.
	JMP	gck99


GetConfigKey		ENDP



;============================================
; strcmpi()
;
; Case-insensitive string comparator
;
; On entry,
;   ESI--> string numero uno
;   EDI--> string numero dos
;
; On exit,
;   EAX = result of comparison
;   (FALSE = no match, anything else = match)
;============================================

strcmpi		PROC

scmp0:	LODSB				;One byte in AL,
	MOV	AH, BYTE PTR [EDI]	;  other in AH.
	INC	EDI
	OR	AX, AX			;If both zero,
	JZ	scmp8			;  we have a match.
	OR	AL, AL			;If only one is zero,
	JZ	scmp7			;  no match.
	OR	AH, AH
	JZ	scmp7
; Nonzero chars: if 'a'-'z', make uppercase:
	CMP	AL, 'a'
	JB	scmp1
	CMP	AL, 'z'
	JA	scmp1
	AND	AL, 5FH			;Make uppercase
scmp1:	CMP	AH, 'a'
	JB	scmp2
	CMP	AH, 'z'
	JA	scmp2
	AND	AH, 5FH			;Make uppercase
scmp2:	CMP	AH, AL			;Match?
	JE	scmp0			;  Yes, keep on truckin'.
scmp7:	XOR	EAX, EAX		;No match, return FALSE.
	RET

scmp8:	MOV	EAX, TRUE
	RET	

strcmpi		ENDP


	END

