;============================================
; libtest -- testbed for GetOurConfig() library routine
;
;============================================


	include \masm32\include\masm32rt.inc
	include	config.inc
	includelib config.lib


;============================================
; Defines, macros, prototypes, etc.
;============================================

WinMain			PROTO :DWORD

$mainWindowWidth	EQU 500
$mainWindowHeight	EQU 500

$listWinID		EQU 2000
$listWinX		EQU 0
$listWinY		EQU 0
$listWinWidth		EQU $mainWindowWidth
$listWinHeight		EQU $mainWindowHeight


;===== Window styles: =====
$mainWinAttrs		EQU WS_OVERLAPPEDWINDOW OR WS_CLIPCHILDREN
$listWinAttrs		EQU WS_CHILD OR WS_BORDER OR WS_VISIBLE OR LBS_HASSTRINGS OR LBS_NOSEL OR LBS_USETABSTOPS

;===== Window background colors: =====
$bkRED			EQU 254
$bkGRN			EQU 243
$bkBLUE			EQU 199

$BkColor		EQU $bkRED OR ($bkGRN SHL 8) OR ($bkBLUE SHL 16)

$tab		EQU 9
$cr		EQU 13
$lf		EQU 10
$dblquote	EQU 34


;============================================
; HERE BE DATA
;============================================
.data

InstanceHandle		HWND ?
MainWinHandle		HWND ?
ListWinHandle		HWND ?

MainClassName		DB "LibTest", 0
ListboxClassName	DB "listbox", 0

MainTitleText		DB "Library Test Program"
NullString		DB 0

ModuleName		DB "getconfig", 0

unknownerrmsg		db "Unknown error???", 0
fnferrmsg		db "File not found", 0
readerrmsg		db "Error reading file", 0
memerrmsg		db "Memory error", 0
toobigerrmsg		db "File too big", 0
parseerrmsg		db "Syntax error", 0

heremsg			db "Here I is!", 0
keydisplaymsg		db "Key=", $dblquote, "%s", $dblquote, $tab, "value=", $dblquote, "%s", $dblquote, 0
keyNULLdisplaymsg	db "Key=", $dblquote, "%s", $dblquote, $tab, "value=<NULL>", 0



;============================================
; CODE LIVES HERE
;============================================
.code


start:
	INVOKE	GetModuleHandle, NULL
	MOV	InstanceHandle, EAX

	INVOKE	WinMain, EAX
	INVOKE	ExitProcess, EAX


;====================================================================
; Mainline proc
;====================================================================

WinMain	PROC hInst:DWORD
	LOCAL	wc:WNDCLASSEX, msg:MSG, brush:HBRUSH, wX:DWORD, wY:DWORD
	LOCAL	keyPtr:DWORD
	LOCAL	buffer[200]:BYTE


; Create  brush to set background color:
	INVOKE	CreateSolidBrush, $BkColor
	MOV	brush, EAX

; Register class for parent window:
	MOV	wc.cbSize, SIZEOF WNDCLASSEX
	MOV	wc.style,  CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
	MOV	wc.lpfnWndProc, OFFSET MainWindowProc
	MOV	wc.cbClsExtra, NULL
	MOV	wc.cbWndExtra, NULL
	MOV	EAX, hInst
	MOV	wc.hInstance, EAX
	MOV	EAX, brush
	MOV	wc.hbrBackground, EAX
	MOV	wc.lpszMenuName,  NULL
	MOV	wc.lpszClassName, OFFSET MainClassName
	MOV	wc.hIcon, NULL
	INVOKE	LoadCursor, NULL, IDC_ARROW
	MOV	wc.hCursor, EAX
	MOV	wc.hIconSm, 0
	INVOKE	RegisterClassEx, ADDR wc

	INVOKE	GetSystemMetrics, SM_CXSCREEN
	MOV	EDX, $mainWindowWidth
	CALL	CenterDim
	MOV	wX, EAX
	INVOKE	GetSystemMetrics, SM_CYSCREEN
	MOV	EDX, $mainWindowHeight
	CALL	CenterDim
	MOV	wY, EAX

; Create our main window:

	INVOKE	CreateWindowEx, WS_EX_OVERLAPPEDWINDOW, ADDR MainClassName, ADDR MainTitleText,
		$mainWinAttrs, wX, wY, $mainWindowWidth, $mainWindowHeight,
		NULL, NULL, hInst, NULL
	MOV	MainWinHandle, EAX
	INVOKE	ShowWindow, EAX, SW_SHOWNORMAL

;=====  Read configuration file into key table:  =====

	INVOKE	GetOurConfig, ADDR ModuleName, ADDR keyPtr
	OR	EAX, EAX				;If no error,
	JZ	showkeys				;  display keys in list box.
	CMP	EAX, GOC_GOC_FILE_NOT_FOUND
	JE	filenotfound
	CMP	EAX, GOC_READ_ERROR
	JE	readerror
	CMP	EAX, GOC_FILE_TOO_BIG
	JE	filetoobig
	CMP	EAX,  GOC_PARSE_ERROR
	JE	parseerror
	CMP	EAX, GOC_MEMORY_ERROR
	JNE	unknownerror
	LEA	EAX, memerrmsg
	JMP	SHORT showerror
unknownerror:
	LEA	EAX, unknownerrmsg
	JMP	SHORT showerror

filenotfound:
	LEA	EAX, fnferrmsg
	JMP	SHORT showerror

readerror:
	LEA	EAX, readerrmsg
	JMP	SHORT showerror

filetoobig:
	LEA	EAX, toobigerrmsg
	JMP	SHORT showerror

parseerror:
	LEA	EAX, parseerrmsg

showerror:
	INVOKE	MessageBox, 0, EAX, NULL, MB_OK
	JMP	SHORT exit99

;============= Message loop ===================
msgloop:
	INVOKE	GetMessage, ADDR msg, NULL, 0, 0
	OR	EAX, EAX				;EAX = 0 = exit
	JZ	exit99
	INVOKE	TranslateMessage, ADDR msg
	INVOKE	DispatchMessage, ADDR msg
	JMP	msgloop

exit99:	CALL	FreeConfigMem
	MOV	EAX, msg.wParam
	RET

showkeys:
; Create listbox control:
	INVOKE	CreateWindowEx, 0, ADDR ListboxClassName, ADDR NullString,
		$listWinAttrs, $listWinX, $listWinY, $listWinWidth, $listWinHeight,
		MainWinHandle, $listWinID, InstanceHandle, NULL
	MOV	ListWinHandle, EAX
	PUSH	EBX
	MOV	EBX, keyPtr
sk10:	MOV	EAX, [EBX + $key.key]
	CMP	EAX, -1
	JNE	sk20
	POP	EBX
	INVOKE	UpdateWindow, ListWinHandle
	JMP	msgloop

sk20:	MOV	EDX, [EBX + $key.val]
	CMP	BYTE  PTR [EDX], NULL
	JNE	sk25
	INVOKE	wsprintf, ADDR buffer, ADDR keyNULLdisplaymsg, EAX
	JMP	SHORT sk30
sk25:	INVOKE	wsprintf, ADDR buffer, ADDR keydisplaymsg, EAX, EDX
sk30:	INVOKE	SendMessage, ListWinHandle, LB_ADDSTRING, 0, ADDR buffer
	ADD	EBX, SIZEOF $key
	JMP	sk10
	

WinMain		ENDP


;====================================================================
; Main Window Proc
;====================================================================

MainWindowProc	PROC hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

	MOV	EAX, uMsg
	CMP	EAX, WM_COMMAND
	JE	dowincmd
	CMP	EAX, WM_CREATE
	JE	docreate
	CMP	EAX, WM_CLOSE
	JE	doclose

dodefault:
; use DefWindowProc for all other messages:
	INVOKE	DefWindowProc, hWin, uMsg, wParam, lParam
	RET

dowincmd:

docreate:
	XOR	EAX, EAX
	RET

doclose:
	INVOKE	PostQuitMessage, NULL
	MOV	EAX, TRUE
	RET


MainWindowProc	ENDP


;====================================================================
; CenterDim
;
; Returns half screen dimension (X or Y) minus half window dimension
;
; On entry,
;	EAX = screen dimension
;	EDX = window dimension
;
; Returns:
;	sdim/2 - wdim/2
;====================================================================

CenterDim	PROC

	SHR	EAX, 1				;divide screen dimension by 2
	SHR	EDX, 1				;divide window dimension by 2
	SUB	EAX, EDX
	RET					;Return w/# in EAX

CenterDim	ENDP


	END	start

